## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global forgeurl https://github.com/oracle/ktls-utils
%global baseversion 0.9

Name:           ktls-utils
Version:        %{baseversion}
Release:        %{autorelease}
Summary:        TLS handshake agent for kernel sockets

%forgemeta

License:        GPL-2.0-only AND (GPL-2.0-only OR BSD-3-Clause) AND GPL-1.0-or-later
URL:            %{forgeurl}

# FIXME: is this a bug in the tagging scheme or forgesource macro?
Source0:        %{forgeurl}/releases/download/%{name}-%{baseversion}/%{name}-%{baseversion}.tar.gz

BuildRequires:  bash systemd-rpm-macros
BuildRequires:  gcc make coreutils
BuildRequires:  pkgconfig(gnutls) >= 3.3.0
BuildRequires:  autoconf >= 2.69
BuildRequires:  automake
BuildRequires:  pkgconfig(libkeyutils)
BuildRequires:  pkgconfig(glib-2.0) >= 2.6
BuildRequires:  pkgconfig(libnl-3.0) >= 3.1

%description
In-kernel TLS consumers need a mechanism to perform TLS handshakes
on a connected socket to negotiate TLS session parameters that can
then be programmed into the kernel's TLS record protocol engine.

This package of software provides a TLS handshake user agent that
listens for kernel requests and then materializes a user space
socket endpoint on which to perform these handshakes. The resulting
negotiated session parameters are passed back to the kernel via
standard kTLS socket options.


%prep
%setup -q -n %{name}-%{baseversion}
%autopatch -p1

%build
./autogen.sh
%configure --with-systemd
%make_build

%install
%make_install

%files
%config(noreplace) %{_sysconfdir}/tlshd.conf
%{_sbindir}/tlshd
%{_mandir}/man5/tlshd.conf.5.gz
%{_mandir}/man8/tlshd.8.gz
%{_unitdir}/tlshd.service
%license COPYING
%doc README.md
%doc SECURITY.md

%post
%systemd_post tlshd.service

%preun
%systemd_preun tlshd.service

%postun
%systemd_postun_with_restart tlshd.service

%changelog
* Fri Jun 09 2023 Jeff Layton <jlayton@kernel.org> - 0.9-1
- Update to official 0.9 release.

* Tue May 16 2023 Jeff Layton <jlayton@kernel.org> - 0.8^20230516.gc60fab91ef83-1
- Update to more recent 0.9 prerelease

* Wed Apr 26 2023 Jeff Layton <jlayton@kernel.org> - 0.8^20200426.g29431d9e988f-1
- Update to 0.9-pre snapshot

* Tue Apr 25 2023 Jeff Layton <jlayton@kernel.org> - 0.8-8
- Make tlshd use the distro-wide preferences for cipher selection

* Tue Apr 25 2023 Jeff Layton <jlayton@kernel.org> - 0.8-7
- Fix the License: string

* Mon Apr 24 2023 Jeff Layton <jlayton@kernel.org> - 0.8-6
- BuildRequires fixes

* Mon Apr 24 2023 Jeff Layton <jlayton@kernel.org> - 0.8-5
- Fix Source0 URL:

* Mon Apr 24 2023 Jeff Layton <jlayton@kernel.org> - 0.8-4
- Fix the the license identifier to use SPDX compatible names

* Tue Apr 18 2023 Jeff Layton <jlayton@kernel.org> - 0.8-3
- Bump the releasever to ensure this replaces hand-built 0.8-2 package

* Tue Apr 18 2023 Jeff Layton <jlayton@kernel.org> - 0.8-2
- Mark tlshd.conf as %%config(noreplace)

* Mon Apr 17 2023 Jeff Layton <jlayton@kernel.org> - 0.8-1
- Initial 0.8 release
